#include "mbed.h"
#include "use_can_stm.h"
#include "use_can_stm.cpp"
#define CanStm_RD PA11
#define CanStm_XD PA12

Serial PC(USBTX,USBRX,115200);
float V1,V2,V3,V4,lx,ly;
float cw,ccw;//モータードライバーにPWMする値
Ticker purppo;//CANの受け取り
CanStm Can1;

void read();
void v1d();
void V_data();
PwmOut P1cw(D1);
PwmOut P1ccw(D9);

union V1_data{float fv1;char cv1[4];};
V1_data Data1;

union V2_data{float fv2;char cv2[4];};
V2_data Data2;                              //CANでfloat受け取るためのユニオン




int main()
{  
    purppo.attach(&V_data,0.01f);
    
    Can1.init(CAN_500KHZ);
    P1cw.period(0.00005f);
    P1ccw.period(0.00005f);

    Can1.attach(0x110,&v1d,RX_FIFO0);
   
   
    while(1) {
             
              ly=Data2.fv2;
              lx=Data1.fv1;
             
             
             
             
             P1ccw.write(ccw);//Ｖ1の逆転出力
             P1cw.write(cw);   //Ｖ1の正転出力
           
              V1=((-lx)+(ly))/2.0f;
              V2=((-lx)+(-ly))/2.0f;
              V3=((lx)+(-ly))/2.0f;
              V4=((lx)+(ly))/2.0f;//各Ⅴ成分の計算
             
  
         
         PC.printf("lx=%f,ly=%f,V1=%f,V2=%f,V3=%f,V4=%f\n\r",lx,ly,V1,V2,V3,V4);
    }
}

    
void v1d() {
              Can1.receive();
             
              Data1.cv1[0]=Can1.getData(RX_DATA_0);
              Data1.cv1[1]=Can1.getData(RX_DATA_1);
              Data1.cv1[2]=Can1.getData(RX_DATA_2);
              Data1.cv1[3]=Can1.getData(RX_DATA_3);//LXのデータ受け取り
              
              Data2.cv2[0]=Can1.getData(RX_DATA_4);
              Data2.cv2[1]=Can1.getData(RX_DATA_5);
              Data2.cv2[2]=Can1.getData(RX_DATA_6);
              Data2.cv2[3]=Can1.getData(RX_DATA_7);//LYのデータ受け取り
             
    }
    void V_data(){
                    if(V1>0){
                 cw=(fabs(V1));ccw=0;//cwにPWM出力
                 }
             else if(V1<0){
                 ccw=(fabs(V1));cw=0;//ccwにPWM出力
                 }
            else if(V1==0){cw=0;ccw=0;}
        
        
        
        }





    
